﻿using System;
using System.Linq;

namespace RepositoryPattern.Console
{
    class Program
    {
        private static Model.Repository.IUnitOfWork contexto;

        static void Main(string[] args)
        {
            contexto = new EF.UnitOfWork();

            List();

            Create();
            List();

            Update();
            List();

            Delete();
            List();

            System.Console.ReadLine();
        }
        private static void List()
        {
            System.Console.WriteLine("======= LISTAGEM DE PRODUTOS =======");
            foreach (var produto in contexto.Produto.GetAll())
            {
                System.Console.WriteLine("Id: {0}, Descricao: {1}, Categoria: {2}, Data Cadastro: {3:d}, Valor Unitário: {4:n2}",
                    produto.Id, produto.Descricao, produto.Categoria.Nome, produto.DataCadastro, produto.ValorUnitario);
            }
            System.Console.WriteLine("====================================");
        }
        private static void Create()
        {
            var novoProduto = new Model.Produto();
            novoProduto.Descricao = "Novo produto";
            novoProduto.Categoria = contexto.CategoriaProduto.GetAll().First();
            novoProduto.DataCadastro = DateTime.Now;
            novoProduto.ValorUnitario = 2.34m;
            contexto.Produto.Add(novoProduto);
            contexto.Save();

            System.Console.WriteLine("====================================");
            System.Console.WriteLine("PRODUTO CADASTRADO COM SUCESSO");
            System.Console.WriteLine("====================================");
        }
        private static void Update()
        {
            var produto = contexto.Produto.GetAll().Last();
            produto.Descricao = "Produto alterado";
            contexto.Save();

            System.Console.WriteLine("====================================");
            System.Console.WriteLine("PRODUTO ALTERADO COM SUCESSO");
            System.Console.WriteLine("====================================");
        }
        private static void Delete()
        {
            var produto = contexto.Produto.GetAll().Last();
            contexto.Produto.Remove(produto);
            contexto.Save();

            System.Console.WriteLine("====================================");
            System.Console.WriteLine("PRODUTO EXCLUÍDO COM SUCESSO");
            System.Console.WriteLine("====================================");
        }
    }
}
