﻿using System.Collections.Generic;
using System.Linq;

namespace RepositoryPattern.EF
{
    public abstract class Repository<T> : Model.Repository.IRepository<T> where T : class
    {
        protected System.Data.Entity.DbSet<T> _dbSet;

        public Repository(System.Data.Entity.DbSet<T> dbSet)
        {
            _dbSet = dbSet;
        }

        public virtual void Add(T entity)
        {
            _dbSet.Add(entity);
        }

        public virtual IEnumerable<T> GetAll()
        {
            return _dbSet.AsEnumerable();
        }

        public virtual void Remove(T entity)
        {
            _dbSet.Remove(entity);
        }
    }
}
