﻿namespace RepositoryPattern.EF
{
    public class UnitOfWork : Model.Repository.IUnitOfWork
    {
        private Contexto _contexto;

        private Model.Repository.ICategoriaProdutoRepository _categoriaProduto;
        public Model.Repository.ICategoriaProdutoRepository CategoriaProduto
        {
            get
            {
                return _categoriaProduto;
            }
        }

        private Model.Repository.IProdutoRepository _produto;
        public Model.Repository.IProdutoRepository Produto
        {
            get
            {
                return _produto;
            }
        }

        public UnitOfWork()
        {
            _contexto = new Contexto();
            _categoriaProduto = new CategoriaProdutoRepository(_contexto.CategoriaProduto);
            _produto = new ProdutoRepository(_contexto.Produto);
        }

        public void Save()
        {
            _contexto.SaveChanges();
        }
    }
}
