﻿Public Class ProdutoRepository
    Inherits Repository(Of Model.VB.Produto)
    Implements Model.VB.Repository.IProdutoRepository

    Public Overrides Sub Add(ByVal Entity As Model.VB.Produto) Implements Model.VB.Repository.IProdutoRepository.Add
        If (Entity.Id = 0) Then
            Entity.Id = (Me.GetMaxId + 1)
        End If

        MyBase.Add(Entity)
    End Sub

    Public Function GetProdutosPorCategoria(ByVal Categoria As Model.VB.CategoriaProduto) As IEnumerable(Of Model.VB.Produto) Implements Model.VB.Repository.IProdutoRepository.GetProdutosPorCategoria
        Return Lista.Where(Function(p) p.Categoria Is Categoria).AsEnumerable
    End Function

    Private Function GetMaxId() As Integer
        Dim MaxId = 0
        If Lista.Any Then
            MaxId = Lista.Max(Function(p) p.Id)
        End If

        Return MaxId
    End Function
End Class