﻿using System.Collections.Generic;
using System.Linq;

namespace RepositoryPattern.InMemory
{
    public class ProdutoRepository : Repository<Model.Produto>, Model.Repository.IProdutoRepository
    {
        public override void Add(Model.Produto entity)
        {
            if (entity.Id == 0)
            {
                entity.Id = GetMaxId() + 1;
            }
            base.Add(entity);
        }
        public IEnumerable<Model.Produto> GetProdutosPorCategoria(Model.CategoriaProduto categoria)
        {
            return _lista.Where(p => p.Categoria == categoria).AsEnumerable();
        }
        private int GetMaxId()
        {
            var maxId = 0;

            if (_lista.Any())
            {
                maxId = _lista.Max(p => p.Id);
            }

            return maxId;
        }
    }
}
